/* preferences.h
 * Copyright (C) 2001 The University of Newcastle upon Tyne
 *
 * Written by Paul Coates (Paul.Coates@ncl.ac.uk)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 */

#ifndef PREFS_H
#define PREFS_H 1

#include <gtk/gtk.h>
#include <gnome-xml/tree.h>
#include <gnome-xml/parser.h>

class Main;
class Preferences
{
	public:
		Preferences(Main *m);
		~Preferences();

		void show();
		void hide();

		void build_sidebar();
		GtkWidget *sidebar_button(char *label);
		void sidebar_icon(GtkWidget *w, char *label, char *fname, int pg);
		void sidebar_pad(GtkWidget *w);
		void sidebar_button_pressed(GtkWidget *w);
		void sidebar_icon_pressed(GtkWidget *w);

		void select_import(int r);
		void unselect_import();
		void add_import();
		void del_import();
		void set_config_from_import();
		void set_import_from_config();
		void import_import();

		void select_community(int r);
		void unselect_community();
		void add_community();
		void del_community();
		void set_config_from_community();
		void set_community_from_config();

		void notify_combo();
		void notify_test();

		void load();
		void save();
		void pref_copies();
		void load_settings();
		void save_settings();
		void set_graph_from_config();

		Main *main;
		int community_row;
		int import_row;
		int state;

		GtkWidget *window;
		GtkWidget *button1;
		GtkWidget *button2;
		GtkWidget *sidebar;
		GtkWidget *notebook;
		GtkWidget *notebook1;
		GtkWidget *current_panel;
		GSList *button_group;

		GtkWidget *entry9;
		GtkWidget *entry10;
		GtkWidget *entry11;
		GtkWidget *entry13;
		GtkWidget *entry22;
		GtkWidget *entry23;
		GtkWidget *comboentry5;
		GtkWidget *fileentry2;
		GtkWidget *combo9;
		GtkWidget *combo10;
		GtkWidget *combo12;
		GtkWidget *combo13;
		GtkWidget *combo14;
		GtkWidget *combo15;
		GtkWidget *clist2;
		GtkWidget *clist3;
		GtkWidget *clist4;
		GtkWidget *clist5;
		GtkWidget *entry5;
		GtkWidget *entry8;
		GtkWidget *entry16;
		GtkWidget *entry19;
		GtkWidget *entry20;
		GtkWidget *entry21;
		GtkWidget *entry6;
		GtkWidget *entry7;
		GtkWidget *entry17;
		GtkWidget *entry18;
		GtkWidget *button7;
		GtkWidget *button8;
		GtkWidget *button9;
		GtkWidget *button10;
		GtkWidget *button13;
		GtkWidget *button15;
		GtkWidget *checkbutton1;
		GtkWidget *checkbutton2;
		GtkWidget *checkbutton3;
		GtkWidget *checkbutton4;
		GtkWidget *checkbutton5;
		GtkWidget *checkbutton6;
		GtkWidget *checkbutton7;
		GtkWidget *checkbutton9;
		GtkWidget *colorpicker2;
		GtkWidget *colorpicker3;
		GtkWidget *colorpicker6;
		GtkWidget *colorpicker7;

		gboolean save_current_view;
};

gchar *get_community_list_string();
void set_config_from_editable(GtkWidget *w, gchar *config);
void set_config_from_time(GtkWidget *w, GtkWidget *w2, gchar *config);
void set_config_from_colour(GtkWidget *w, gchar *config);
void set_config_from_togglebutton(GtkWidget *w, gchar *config);

void set_editable_from_config(GtkWidget *w, gchar *config);
void set_time_from_config(GtkWidget *w, GtkWidget *w2, gchar *config);
void set_colour_from_config(GtkWidget *w, gchar *config);
void set_togglebutton_from_config(GtkWidget *w, gchar *config);
gchar *user_file(gchar *fname);

#endif

