#ifndef DEVICE_H
#define DEVICE_H 1

#include <gnome-xml/tree.h>
#include <gnome-xml/parser.h>
#include "timestamp.h"
#include "visual.h"
#include "list.h"
#include "ipaddress.h"

class Filter;
class Device : public Visual
{
	public:
		Device();
		~Device();

		void empty();
		void savexml(xmlNodePtr xmlnode);
		void loadxml(xmlNodePtr xmlnode);
		void match(char *str);
		void matchfilter(Filter *f);

		IPAddress pingname;
		char name[65];
		TimeStamp last_seen;
		char location[65];
		char community[65];
		char descr[65];
		char contact[65];
		char status;
		char group;
		char registered;
		char matrix;
		char grab_top;
		char grab_stats;
		List interfaces;

		char being_grabbed;
		char find;
};

int compare_device_names(Link *a, Link *b);
int compare_device_ips(Link *a, Link *b);

#endif

